#
# extrefparser.rb
#
#   Copyright (c) 2001,2002 Minero Aoki <aamine@loveruby.net>
#
#   This program is free software.
#   you can distribute/modify this program under the terms of
#   the GNU General Public License version 2 or later.
#

module ReFe

  class ExtentionAPIReferenceParser

    ::ReFe.declear_parser self

    def self.process( fname, db, msgout )
      msgout.print_filename fname
      db.f_doc_updating {
          File.open( fname ) {|f|
              new.parse f, db
          }
      }
    end


    def parse( f, db )
      file_to_hash(f).each do |name,str|
        db.register_fdoc name, str.strip
      end
    end

    private

    def file_to_hash( f )
      table = {}
      curr = nil

      f.each do |line|
        next if /\A[=\w]/ === line
        if /\A: / === line then
          m = /\A: .*?(\w+)(\(|$)/.match(line) or
                  raise "parse failed: #{line.inspect}"
          curr = line
          table[ m[1] ] = curr
        else
          curr << line if curr
        end
      end

      table
    end
  
  end

end
